unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    dlgColor: TColorDialog;
    Image1: TImage;
    ImageList1: TImageList;
    Label1: TLabel;
    mnuOrThisLastOne: TMenuItem;
    mnuOrThis: TMenuItem;
    mnuColor: TMenuItem;
    mnuThis: TMenuItem;
    Panel1: TPanel;
    popColor: TPopupMenu;
    procedure FormCreate(Sender: TObject);
    procedure mnuThisClick(Sender: TObject);
  private
    procedure SetBitmapColor(bm:TBitmap;col:Tcolor);
  public

  end;

const
  //color bitmap size
  bmW = 10;
  bmH = 10;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  bmp: TBitmap;
begin
  ImageList1.Width := bmW;
  ImageList1.Height := bmH;

  bmp := TBitmap.Create;
  try
    bmp.SetSize(ImageList1.Width, ImageList1.Height);
    bmp.Canvas.Handle;  // Force creation of handle
    ImageList1.Clear;
    SetBitmapColor(bmp, clBlue);
    mnuThis.ImageIndex := ImageList1.Add(bmp, nil);
    SetBitmapColor(bmp, clRed);
    mnuOrThis.ImageIndex := ImageList1.Add(bmp, nil);
    SetBitmapColor(bmp, clGreen);
    mnuOrThisLastOne.ImageIndex := ImageList1.Add(bmp, nil);
  finally
    bmp.Free;
  end;
end;

procedure TForm1.mnuThisClick(Sender: TObject);
var
  bmp: TBitmap;
  mi: TMenuItem;
begin
  mi := Sender as TMenuItem;
  bmp := TBitmap.Create;
  try
    ImageList1.GetBitmap(mi.ImageIndex, bmp);
    dlgColor.Color := bmp.Canvas.Pixels[bmp.Width div 2, bmp.Height div 2];
    dlgColor.Title := 'Extended CQ (DX, NA, SA ...) - color';
    if dlgColor.Execute then begin
      SetBitmapColor(bmp, dlgColor.Color);
      ImageList1.Replace(mi.ImageIndex, bmp, nil);
      Image1.Picture.Assign(bmp);
    end;
  finally
    bmp.Free;
  end;
end;

procedure TForm1.SetBitmapColor(bm: TBitmap; col: Tcolor);
begin
  with bm do
  Begin
    Width  := ImageList1.Width;
    Height := ImageList1.Height;
    with Canvas do
    Begin
      Brush.Style := bsSolid;
      Brush.Color := Col;
      FillRect(0, 0, Width, Height);
    end;
  end;
end;



end.

